<?php
/**
 * Widget for displaying the trending posts.
 *
 * @package Blogbuster
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

class Blogbuster_Trending_Posts extends WP_Widget {

    /**
     * Registers the widget with WordPress.
     */
    public function __construct() {
        $widget_ops = array( 
            'classname'                     => 'blogbuster-widget blogbuster_trending_posts',
            'description'                   => __( 'Display trending posts in various layouts.', 'blogbuster' ),
            'customize_selective_refresh'   => true,
        );
        parent::__construct( 'blogbuster_trending_posts', __( 'MT: Trending Posts', 'blogbuster' ), $widget_ops );
    }

    /**
     * Helper function that defines widget fields.
     * 
     * The array is used in the update and form functions.
     */
    private function widget_fields() {
        
        $fields = array(
            'widget_title' => array(
                'widget_field_name'         => 'widget_title',
                'widget_field_title'        => __( 'Widget Title', 'blogbuster' ),
                'widget_field_default'      => __( 'Trending Posts', 'blogbuster' ),
                'widget_field_type'         => 'title',
                'widget_field_placeholder'  => __( 'Widget Title', 'blogbuster' )
            ),
            'posts_count' => array(
                'widget_field_name'     => 'posts_count',
                'widget_field_title'    => __( 'No. of posts', 'blogbuster' ),
                'widget_field_default'  => 6,
                'widget_field_type'     => 'number',
                'input_attr'            => array(
                    'min'   => 1,
                    'max'   => 10,
                    'step'  => 1
                )
            ),
            
        );

        return $fields;

    }

    /**
     * Front-end display of the widget.
     *
     * @see WP_Widget::widget()
     *
     * @param array $args     Widget arguments.
     * @param array $instance Saved values from the database.
     */
    public function widget( $args, $instance ) {
        extract( $args );
        if ( empty( $instance ) ) {
            return;
        }

        $widget_title = empty( $instance['widget_title'] ) ? '' : $instance['widget_title'];
        $posts_count = empty( $instance['posts_count'] ) ? 6 : $instance['posts_count'];

        $trending_args = array(
            'posts_per_page'        => absint( $posts_count ),
            'orderby'               => 'comment_count',
            'ignore_sticky_posts'   => true
        );

        $trending_query = new WP_Query( $trending_args );

        $widget_custom_classes[] = 'trending-posts-wrapper';

        echo $before_widget;
    ?>
        <div class="mt-aside <?php echo esc_attr( implode( ' ', $widget_custom_classes ) ); ?>">
            <?php
                if ( ! empty( $widget_title ) ) {
                    echo $before_title . wp_kses_post( $widget_title ) . $after_title;
                }
            ?>
            <div class="posts-wrapper trending-posts cS-hidden">
                <?php
                    if ( $trending_query->have_posts() ) :
                        $post_count = 1;
                        while ( $trending_query->have_posts() ) :
                            $trending_query->the_post();
                            $post_img = has_post_thumbnail() ? 'has-image' : 'no-image';
                ?>
                            <div class="post-wrap <?php echo esc_attr( $post_img ); ?>">
                                <div class="post-thumbnail-wrap">
                                    <?php blogbuster_post_thumbnail( 'thumbnail' ); ?>
                                    <span class="post-count"><?php echo absint( $post_count ); ?></span>
                                </div><!-- .post-thumbnail-wrap -->
                                <div class="post-content-wrap">
                                    <div class="post-title-wrap">
                                        <?php the_title( '<h3 class="entry-title"><a href="' . esc_url( get_permalink() ) . '" rel="bookmark">', '</a></h3>' ); ?>
                                    </div><!-- .post-title-wrap -->
                                </div><!-- .post-content-wrap -->
                            </div><!-- .post-wrap -->
                <?php
                        $post_count ++;
                        endwhile;

                    endif;
                ?>
            </div><!-- .posts-wrapper -->
        </div><!-- .mt-aside -->

    <?php
        echo $after_widget;
    }

    /**
     * Sanitizes widget form values as they are saved.
     *
     * @see WP_Widget::update()
     *
     * @param array $new_instance Values just sent to be saved.
     * @param array $old_instance Previously saved values from the database.
     *
     * @uses blogbuster_widget_updated_field_value() Defined in blogbuster-widgets-helper.php
     *
     * @return array Updated safe values to be saved.
     */
    public function update( $new_instance, $old_instance ) {
        $instance = $old_instance;

        $widget_fields = $this->widget_fields();

        // Loop through fields
        foreach ( $widget_fields as $widget_field ) {

            extract( $widget_field );

            // Use helper function to get updated field values
            $instance[$widget_field_name] = blogbuster_widget_updated_field_value( $widget_field, $new_instance[$widget_field_name] );
        }

        return $instance;
    }

    /**
     * Back-end widget form.
     *
     * @see WP_Widget::form()
     *
     * @param array $instance Previously saved values from the database.
     *
     * @uses blogbuster_show_widget_field() Defined in blogbuster-widgets-helper.php
     */
    public function form( $instance ) {

        $widget_fields = $this->widget_fields();

        // Loop through fields
        foreach ( $widget_fields as $widget_field ) {

            // Make array elements available as variables
            extract( $widget_field );

            if ( empty( $instance ) && isset( $widget_field_default ) ) {
                $widget_field_value = $widget_field_default;
            } elseif ( empty( $instance ) ) {
                $widget_field_value = '';
            } else {
                $widget_field_value = $instance[$widget_field_name];
            }
            blogbuster_show_widget_field( $this, $widget_field, $widget_field_value );
        }
    }

} //end Class Blogbuster_Trending_Posts